#include <bits/stdc++.h>
using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	long long n;
	cin >> n;
	long long q;
	cin >> q;
	long long d[n];
	long long p[n];
	long long k[q];
	long long qmax = 0;
	
	for(int i = 0; i < n; i++){
		cin >> d[i] >> p[i];
	}
	
	for(int i = 0; i < q; i++){
		cin >> k[i];
		if(k[i] > qmax){
			qmax = k[i];
		}
	}
	
	int brojac[qmax + 1] = {0};
	int brojac1[qmax + 1] = {0};
	
	for(int i = 0; i < n; i++){
		brojac[d[i]] += p[i];
	}
	
	for(int i = 1; i <= qmax; i++){
		brojac[i] += brojac[i - 1];
		if(brojac[i] > 0){
			brojac1[i] = brojac1[i - 1] + 1;
			brojac[i]--;
		}
		else{
			brojac1[i] = brojac1[i - 1];
		}
	}
	
	for(int i = 0; i < q; i++){
		cout << brojac1[k[i]] << '\n';
	}

return 0;
}